/* YC 0.2: Fri Dec 10 11:49:52 CET 1999 */
/* Module-P: AccessControlFormat-prompt-1 */

#ifndef z_accform1_P_H
#define z_accform1_P_H

#include <yaz/z-accform1.h>
#ifdef __cplusplus
extern "C" {
#endif
struct Z_PromptObject1 {
	int which;
	union {
		Z_Challenge1 *challenge;
		Z_Response1 *response;
#define Z_PromptObject1_challenge 1
#define Z_PromptObject1_response 2
	} u;
};

struct Z_ChallengeUnit1 {
	Z_PromptId *promptId;
	Z_InternationalString *defaultResponse; /* OPT */
	int which;
	union {
		Z_InternationalString *character;
		Z_Encryption *encrypted;
#define Z_ChallengeUnit1_character 1
#define Z_ChallengeUnit1_encrypted 2
	} u; /* OPT */
	Z_InternationalString *regExpr; /* OPT */
	Odr_null *responseRequired; /* OPT */
	int num_allowedValues;
	Z_InternationalString **allowedValues; /* OPT */
	Odr_null *shouldSave; /* OPT */
#define Z_ChallengeUnit1_integer 1
#define Z_ChallengeUnit1_date 2
#define Z_ChallengeUnit1_float 3
#define Z_ChallengeUnit1_alphaNumeric 4
#define Z_ChallengeUnit1_url_urn 5
#define Z_ChallengeUnit1_boolean 6
	int *dataType; /* OPT */
	Z_External *diagnostic; /* OPT */
};

struct Z_Challenge1 {
	int num;
	Z_ChallengeUnit1 **elements;
};

struct Z_ResponseUnit1 {
	Z_PromptId *promptId;
	int which;
	union {
		Z_InternationalString *string;
		bool_t *accept;
		Odr_null *acknowledge;
		Z_DiagRec *diagnostic;
		Z_Encryption *encrypted;
#define Z_ResponseUnit1_string 1
#define Z_ResponseUnit1_accept 2
#define Z_ResponseUnit1_acknowledge 3
#define Z_ResponseUnit1_diagnostic 4
#define Z_ResponseUnit1_encrypted 5
	} u;
};

struct Z_Response1 {
	int num;
	Z_ResponseUnit1 **elements;
};

struct Z_PromptIdEnumeratedPrompt {
#define Z_PromptIdEnumeratedPrompt_groupId 0
#define Z_PromptIdEnumeratedPrompt_userId 1
#define Z_PromptIdEnumeratedPrompt_password 2
#define Z_PromptIdEnumeratedPrompt_newPassword 3
#define Z_PromptIdEnumeratedPrompt_copyright 4
#define Z_PromptIdEnumeratedPrompt_sessionId 5
	int *type;
	Z_InternationalString *suggestedString; /* OPT */
};

struct Z_PromptId {
	int which;
	union {
		Z_PromptIdEnumeratedPrompt *enumeratedPrompt;
		Z_InternationalString *nonEnumeratedPrompt;
#define Z_PromptId_enumeratedPrompt 1
#define Z_PromptId_nonEnumeratedPrompt 2
	} u;
};

struct Z_Encryption {
	Odr_oct *cryptType; /* OPT */
	Odr_oct *credential; /* OPT */
	Odr_oct *data;
};

#ifdef __cplusplus
}
#endif
#endif
